# -*- coding: utf-8 -*-

# Jose3D
# Copyright (C) 2007 Jean-Baptiste LAMY
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


import random
import cerealizer
import soya, soya.cerealizer4soya, soya.sdlconst as sdlconst
import jose3d

class Camera(soya.Camera):
  def __init__(self, parent):
    soya.Camera.__init__(self, parent)
    
    self.character = None
    self.delta_x   = 2.0
    self.ideal_y   = -20.0
    
  def advance_time(self, proportion):
    soya.Camera.advance_time(self, proportion)
    
    if self.character: 
      if   self.character.speed.x < 0.0:
        if self.delta_x > -2.0: self.delta_x -= 0.1 * proportion
      elif self.character.speed.x > 0.0:
        if self.delta_x <  2.0: self.delta_x += 0.1 * proportion

    y = self.y
    if   (self.character.speed.y != 0.0) and (self.character.y > self.y + 3.0): y = self.character.y - 3.0
    elif (self.character.speed.y == 0.0) and (self.character.y > self.y + 0.0): y = self.character.y - 0.0
    elif                                      self.character.y < self.y - 3.0 : y = self.character.y + 3.0

    if   y < self.y - 0.15: y = self.y - 0.15
    elif y > self.y + 0.25: y = self.y + 0.25
    
    if y < -17.0: y = -17.0
    
    self.set_xyz(self.character.x + self.delta_x, y, self.character.z + 9.0)
    
