# -*- coding: utf-8 -*-

# Jose3D
# Copyright (C) 2007 Jean-Baptiste LAMY
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


import sys, os, os.path, gettext

import soya
import jose3d
tofu = jose3d.tofu
APPDIR = os.path.dirname(__file__)

soya.path.insert(0, APPDIR)


soya.AUTO_EXPORTERS_ENABLED = os.path.exists(os.path.join(APPDIR, ".svn"))


translator = None
LOCALEDIR = os.path.join(APPDIR, "locale")
try: translator = gettext.translation("jose3d", LOCALEDIR)
except IOError:
  
  LOCALEDIR = os.path.join(APPDIR, "..", "locale")
  try: translator = gettext.translation("jose3d", LOCALEDIR)
  except IOError:
    
    LOCALEDIR = os.path.join("/", "usr", "share", "locale")
    try: translator = gettext.translation("jose3d", LOCALEDIR)
    except IOError:
      
      # Non-supported language, defaults to French
      LOCALEDIR = os.path.join(APPDIR, "locale")
      try: translator = gettext.translation("jose3d", LOCALEDIR, ("fr",))
      except IOError:
        
        LOCALEDIR = os.path.join(APPDIR, "..", "locale")
        try: translator = gettext.translation("jose3d", LOCALEDIR, ("fr",))
        except IOError:
          
          LOCALEDIR = os.path.join("/", "usr", "share", "locale")
          translator = gettext.translation("jose3d", LOCALEDIR, ("fr",))
      
translator.install(1)


FULLSCREEN    = 0
SCREEN_WIDTH  = 800
SCREEN_HEIGHT = 600
MIN_FRAME_DURATION = 0.025

QUALITY = 1

SOUND_VOLUME = 1.0

if sys.platform.startswith("win"):
  try:
    import pymedia
    SOUND_SYSTEM = "pymedia"
  except:
    SOUND_SYSTEM = "none"
else:
  SOUND_SYSTEM = "openal"


FPS_LABEL = 1

CONFIG_FILE = os.path.expanduser(os.path.join("~", ".jose3d/config"))
if CONFIG_FILE[0] == "~": # Fucking winedaube OS !!!
  #CONFIG_FILE = "C:\\jose3d\\config" # Random name...
  CONFIG_FILE = os.path.join(APPDIR, "save", "config")
  

LOGIN = u"JB"

tofu.SAVED_GAME_DIR = os.path.expanduser(os.path.join("~", ".jose3d"))
if tofu.SAVED_GAME_DIR[0] == "~": # Fucking winedaube OS !!!
  #tofu.SAVED_GAME_DIR = "C:\\jose3d" # Random name...
  CONFIG_FILE = os.path.join(APPDIR, "save")

if os.path.exists(CONFIG_FILE):
  try:
    execfile(CONFIG_FILE)
  except:
    import sys
    sys.excepthook(*sys.exc_info())
    print """* Jose3D * Error in config file %s !
Please reconfigure Balazar !
Config file ignored.
""" % CONFIG_FILE



def generate_config_file():
  f = open(CONFIG_FILE, "w")
  f.write("""
FULLSCREEN        = %(FULLSCREEN)s
SCREEN_WIDTH      = %(SCREEN_WIDTH)s
SCREEN_HEIGHT     = %(SCREEN_HEIGHT)s
QUALITY           = %(QUALITY)s

SOUND_VOLUME      = %(SOUND_VOLUME)s

LOGIN             = '%(LOGIN)s'
""" % globals())
  

VERSION = "0.1"

