# -*- coding: utf-8 -*-

# Jose3D
# Copyright (C) 2007 Jean-Baptiste LAMY
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import cerealizer
import soya, soya.cerealizer4soya
import jose3d
tofu = jose3d.tofu

from jose3d.character import Jose


class PlayerID(tofu.PlayerID):
  def __init__(self, filename, password, level = 1):
    tofu.PlayerID.__init__(self, filename, password)
    
    self.level = level
    
tofu.LOAD_PLAYER_ID = PlayerID.loads


class Player(tofu.Player):
  def __init__(self, player_id):
    tofu.Player.__init__(self, player_id)
    
    self.levelid = player_id.level
    self.propositions = set()
    
    self.create_character(1)
    
  def login(self, sock, udp_address):
    if not self.mobiles:
      self.create_character()
      
    tofu.Player.login(self, sock, udp_address)
    
  def create_character(self, new = 0):
    level = tofu.Level.get("level%s" % self.levelid)
    
    if new:
      if self.levelid == 1:
        self.restart_x = 13.0
        self.restart_y = 0.0
        self.restart_z = 11.0
        
        #self.restart_x = 180.0
        #self.restart_y = 0.0
        #self.restart_z = -11.0
        
    jose = Jose()
    jose.level = level
    jose.set_xyz(self.restart_x, self.restart_y, self.restart_z)
    
    self.add_mobile(jose)
    
  def killed(self):
    tofu.Player.killed(self, 1)
    
cerealizer.register(Player)
    
tofu.CREATE_PLAYER = Player
