# Fake setup.py for meta-package -- delegate to other setup.py

import sys, os, os.path, glob, shutil

PACKAGES = ['ode', 'openal', 'pyogg', 'pyvorbis', 'glew', 'cal3d', 'Cerealizer', 'Soya', 'Jose3D']
HERE     = os.path.abspath(os.path.dirname(sys.argv[0]) or os.getcwd())

def do(command):
  print
  print command
  if os.system(command) != 0:
    raise RuntimeError, command
  
os.chdir(HERE)
CFLAGS = "-I @/cal3d/src/cal3d -L @/cal3d/src/cal3d/.libs -I @/glew/include -L @/glew/lib -I @/ode/include -L @/ode/ode/src -I @/openal/include -I @/openal/common/include -L @/openal/src/.libs"
os.putenv("CFLAGS", CFLAGS.replace("@", HERE))

for package in PACKAGES:
  package_dir = package.lower()
  if not os.path.exists(package_dir):
    package_file = glob.glob(package + "-*.tar.*")[0]
    print "Untar-ing %s..." % package_file
    if package_file.endswith(".tar.gz"):
      do("tar -xzf %s" % package_file)
      try: os.rename(package_file[0:-7], package_dir)
      except: pass
    else:
      do("tar -xjf %s" % package_file)
      try: os.rename(package_file[0:-8], package_dir)
      except: pass
      
  if os.path.exists(os.path.join(package_dir, "setup.py")):
    if os.path.exists(os.path.join(package_dir, "config_unix.py")):
      do("cd %s; python config_unix.py" % package_dir)
    do("cd %s; python setup.py %s -f" % (package_dir, " ".join(sys.argv[1:])))
  else:
    if "build" in sys.argv[1:]:
      if os.path.exists(os.path.join(package_dir, "configure")):
        do("cd %s; ./configure" % package_dir)
      do("cd %s; make" % package_dir)
    else:
      do("cd %s; make install" % package_dir)

shutil.copy(glob.glob("./pyvorbis/build/lib.*/ogg/vorbis.so")[0], glob.glob("./pyogg/build/lib.*/ogg")[0])

